import matplotlib.pyplot as plt
import numpy as np
import scipy.stats

N = 10
p = 0.7
p_hat = []
for t in range(10000):
    k = scipy.stats.binom.rvs(N, p)
    p_hat.append(k / N)

plt.hist(p_hat, bins = [-0.025 + i / 20 for i in range(21)])
plt.show()

s_p_hat = np.sort(p_hat)
n_len = s_p_hat.size
cum_s_p_hat = []
for i in range(n_len):
    cum_s_p_hat.append((i + 1) / n_len)
plt.plot(s_p_hat, cum_s_p_hat)
plt.show()

z_p_hat = (s_p_hat - s_p_hat.mean()) / s_p_hat.std()
min_x = z_p_hat.min()
max_x = z_p_hat.max()
x_range = np.arange(min_x, max_x, 0.01)
cum_norm = scipy.stats.norm.cdf(x_range)
plt.plot(z_p_hat, cum_s_p_hat)
plt.plot(x_range, cum_norm, 'r--') 
plt.show()
